jQuery(function($) {
    $(document).ready( function(e) {

        window.ImageUpload = window.ImageUpload || {};
        var ImageUpload = window.ImageUpload;

        ImageUpload.file_frame = null;
        ImageUpload.initialized = false;
        ImageUpload.uploadTriggered = false;
        ImageUpload.uploadButton = undefined;

        ImageUpload.init = function() {
            ImageUpload.initialized = true;

            $(document).on('click', '.upload_button', function(e) {
                e.preventDefault();
                e.stopPropagation();

                if( ImageUpload.uploadTriggered ) return;
                ImageUpload.uploadTriggered = true;
                ImageUpload.uploadButton = $(e.target);

                ImageUpload.file_frame = wp.media.frames.file_frame = wp.media({
                    title: 'Picture',
                    button: {
                        text: "select"
                    },
                    multiple: false
                });

                ImageUpload.file_frame.on( 'select', function() {
                    var attachment = ImageUpload.file_frame.state().get('selection').first().toJSON();
                    ImageUpload.appendImage( attachment );
                });

                ImageUpload.file_frame.on( 'close', function() {
                    ImageUpload.uploadTriggered = false;
                });

                ImageUpload.file_frame.open();
            });

            $(document).on('click', '.image_placeholder .remove', ImageUpload.removeImage );
        };

        ImageUpload.appendImage = function( json ) {
            $(ImageUpload.uploadButton).siblings('.image_placeholder')
                .html(
                    '<span class="ew-image__wrapper img_wrapper">' +
                    '<img class="ew-img__object" src="'+ ImageUpload.createImageSrc(json.url) +'"/>' +
                    '<span class="ew-image__icon--remove remove fa fa-times"></span></span>'
                );
            $(ImageUpload.uploadButton).siblings('.hidden').val(json.url);
            ImageUpload.uploadButton.val('Byt bild');
        };

        ImageUpload.createImageSrc = function(url) {
            return url + '?' + new Date().getTime();
        };

        ImageUpload.removeImage = function(e) {
            var $placeholder = $(e.target).parents('.image_placeholder');
            $placeholder.siblings('.hidden').val('');
            $placeholder.html('');
            ImageUpload.uploadButton.val('Välj bild');
        };

        if( !ImageUpload.initialized ) {
            ImageUpload.init();
        }
    });
});
