/*global oc_ajax*/
/*global translation*/

oc_ajax.oc_ajax_url = oc_ajax.oc_ajax_url || '';
translation.oc_query_result = translation.oc_query_result || '';

//Ajax test OC query from widget
jQuery(function($) {
    var postUrl = oc_ajax.oc_ajax_url || '';
    var classes = {
        testResultWrapperLoaded: 'oc-query-result--loaded',
        testResultHeadline: 'oc-query-result__headline',
        testResultMessage: 'oc-query-result__message',
    };
    var selectors = {
        wrapper: '.oc-query-box',
        testResultWrapper: '.oc-query-result',
        testButton: '.oc-query-test',
        oc: {
            limit: '.oc-query-limit',
            query: '.oc-query-search',
            start: '.oc-query-start',
            sort: '.oc-query-sort',
        },
    };

    var resultWrapper;

    function getQueryData($formWrapper) {
        return {
            action: 'test_oc_query',
            query: $formWrapper.find(selectors.oc.query).val(),
            oc_query_start: $formWrapper.find(selectors.oc.start).val(),
            oc_query_limit: $formWrapper.find(selectors.oc.limit).val(),
            oc_query_sort: $formWrapper.find(selectors.oc.sort).val(),
        }
    }

    $(document).on('click', selectors.testButton, function (e) {
        e.preventDefault();
        var el = e.target,
            $el = $(el),
            $parent = $el.closest(selectors.wrapper),
            queryData = getQueryData($el.closest(selectors.wrapper));

        resultWrapper = $parent.find(selectors.testResultWrapper);

        resultWrapper.empty().append('<i class="fa fa-spinner fa-spin fa-2x fa-fw"></i>').addClass(classes.testResultWrapperLoaded);
        $.post(postUrl, queryData)
            .done(function (data) {
                var result = '<h4 class="oc-query-result__headline">' + translation.oc_query_result + '</h4>';

                var parsedData = $.parseJSON(data);

                for (var obj in parsedData) {
                    if ({}.hasOwnProperty.call(parsedData, obj)) {
                        result += '<p class="oc-query-result__message">' + obj + " : " + parsedData[obj] + '</p>';
                    }
                }

                resultWrapper.empty().append(result);
            });

        return false;
    });
});
